"""Create coordinate arrays for use in vispy."""
import logging
from typing import Any

import numpy as np
import zarr
from numpy import typing as npt
from vispy import scene, visuals


def generate_raster_line(
    spike_times: dict[str, Any],
    cell_list: list[str],
    sample_rate: float,
    spatial_info: npt.NDArray[np.floating] | None = None,
) -> tuple[np.ndarray, np.ndarray, np.ndarray | None]:
    """Generate arrays defining lines for use in vispy.

    Args:
        spike_times (dict): this is directly the object generated by h5py.
        sample_rate (float): sample rate

    Returns:
        tuple[np.ndarray, np.ndarray]: the arrays for vispy
    """
    connect = np.empty(0, dtype=bool)
    coord = np.empty((0, 2))
    col_info = np.empty((0, 4))
    max_info = np.max(spatial_info)
    min_info = np.min(spatial_info)
    for i_cell, cell in enumerate(cell_list):
        times = spike_times[cell]
        coords_i = np.zeros((2 * times.size, 2))
        connect_i = np.zeros(2 * times.size, dtype=bool)
        connect_i[::2] = True
        coords_i[:, 0] = np.repeat(times[:] / sample_rate, 2)
        coords_i[::2, 1] = i_cell
        coords_i[1::2, 1] = i_cell + 1
        connect = np.append(connect, connect_i)
        coord = np.append(coord, coords_i, axis=0)
        if spatial_info is not None:
            col_info_i = np.zeros((times.size * 2, 4))
            col_info_i[:, :3] = 0.2 + 0.8 * (
                spatial_info[i_cell] - min_info
            ) / (max_info - min_info)
            col_info_i[:, 3] = 1.0

            col_info = np.append(col_info, col_info_i, axis=0)

    if spatial_info is not None:
        return coord, connect, col_info
    else:
        return coord, connect, None


def generate_textures(
    spectro: zarr.core.Array, t_range: zarr.core.Array, freqs: zarr.core.Array
) -> list:
    """Split textures to avoid a GL limit.

    Args:
        spectro (zarr.core.Array): the spectrogram array
        t_range (zarr.core.Array): the timestamps
        freqs (zarr.core.Array): the frequencies

    Returns:
        list: the list of vispy views
    """
    # GL displays a bug when trying to display large images because of a limit
    # on texture size
    width_unit = 8192
    n_text = (t_range.size + width_unit - 1) // width_unit
    logging.info("Generate %d textures for the spectro", n_text)

    spectro_viss = []

    sx = (t_range[-1] - t_range[0]) / (t_range.size - 1)
    sy = (freqs[-1] - freqs[0]) / (freqs.size - 1)
    for i_span in range(n_text):
        start = i_span * width_unit
        stop = np.min((t_range.size, (i_span + 1) * width_unit))
        visual_spectro = scene.visuals.Image(
            data=spectro[:, start:stop],
            interpolation="bilinear",
            cmap="cubehelix",
        )

        # transform the image to respect the ranges
        tx = t_range[start]
        ty = freqs[0]

        st_img = visuals.transforms.STTransform(
            scale=(sx, sy), translate=(tx, ty)
        )

        visual_spectro.transform = st_img
        spectro_viss.append(visual_spectro)
    return spectro_viss
